# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions

from ..types.experiment_status import ExperimentStatus
from .base_metric_response import BaseMetricResponseParams
from .experiment_version_response import ExperimentVersionResponseParams
from .positive_label import PositiveLabelParams


class ExperimentResponseParams(typing_extensions.TypedDict):
    id: str
    """
    String ID of experiment. Starts with `exp_`.
    """

    file_id: str
    """
    String ID of file the experiment belongs to.
    """

    name: str
    """
    Name of experiment.
    """

    status: ExperimentStatus
    """
    Status of experiment.
    """

    versions: typing_extensions.NotRequired[typing.Sequence[ExperimentVersionResponseParams]]
    """
    List of Versions associated to the experiment.
    """

    metric: BaseMetricResponseParams
    """
    Metric used as the experiment's objective.
    """

    positive_labels: typing.Sequence[PositiveLabelParams]
    """
    Feedback labels to treat as positive user feedback. Used to monitor the performance of model configs in the experiment.
    """

    created_at: dt.datetime
    updated_at: dt.datetime
