# This file was auto-generated by Fern from our API Definition.

import datetime as dt

import typing_extensions

from .feedback_response_type import FeedbackResponseTypeParams
from .feedback_response_value import FeedbackResponseValueParams


class FeedbackResponseParams(typing_extensions.TypedDict):
    type: FeedbackResponseTypeParams
    """
    The type of feedback. The default feedback types available are 'rating', 'action', 'issue', 'correction', and 'comment'.
    """

    value: FeedbackResponseValueParams
    """
    The feedback value to set. This would be the appropriate text for 'correction' or 'comment', or a label to apply for 'rating', 'action', or 'issue'.
    """

    data_id: typing_extensions.NotRequired[str]
    """
    ID to associate the feedback to a previously logged datapoint.
    """

    user: typing_extensions.NotRequired[str]
    """
    A unique identifier to who provided the feedback.
    """

    created_at: typing_extensions.NotRequired[dt.datetime]
    """
    User defined timestamp for when the feedback was created.
    """

    id: str
    """
    String ID of user feedback. Starts with `ann_`, short for annotation.
    """
