# This file was auto-generated by Fern from our API Definition.

import typing

import typing_extensions

from ..types.tool_source import ToolSource
from .base_models_user_response import BaseModelsUserResponseParams


class ToolConfigResponseParams(typing_extensions.TypedDict):
    id: str
    """
    String ID of config. Starts with `config_`.
    """

    other: typing_extensions.NotRequired[typing.Dict[str, typing.Any]]
    """
    Other parameters that define the config.
    """

    type: typing.Literal["tool"]
    created_by: typing_extensions.NotRequired[BaseModelsUserResponseParams]
    """
    The user who created the config.
    """

    status: str
    """
    Whether the config is committed or not.
    """

    name: str
    """
    Name for the tool referenced by the model.
    """

    description: typing_extensions.NotRequired[str]
    """
    Description of the tool referenced by the model
    """

    source: typing_extensions.NotRequired[ToolSource]
    """
    Source of the tool. If defined at an organization level will be 'organization' else 'inline'.
    """

    source_code: typing_extensions.NotRequired[str]
    """
    Code source of the tool.
    """

    setup_schema: typing_extensions.NotRequired[typing.Dict[str, typing.Any]]
    """
    Definition of parameters needed to run the tool. Provided in jsonschema format: https://json-schema.org/
    """

    parameters: typing_extensions.NotRequired[typing.Dict[str, typing.Any]]
    """
    Definition of parameters needed to run the tool. Provided in jsonschema format: https://json-schema.org/
    """

    signature: typing_extensions.NotRequired[str]
    """
    The function signature of the tool when being called.
    """

    is_preset: typing_extensions.NotRequired[bool]
    """
    Whether the tool is one where Humanloop defines runtime or not.
    """

    preset_name: typing_extensions.NotRequired[str]
    """
    If is_preset = true, this is the name of the preset tool on Humanloop. This is used as the key to lookup the Humanloop runtime of the tool
    """
