# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel
from .environment_tag import EnvironmentTag
from .file_environment_response_file import FileEnvironmentResponseFile


class FileEnvironmentResponse(UncheckedBaseModel):
    """
    Response model for the List Environments endpoint under Files.

    Contains the deployed version of the File, if one is deployed to the Environment.
    """

    id: str
    created_at: dt.datetime
    name: str
    tag: EnvironmentTag
    file: typing.Optional[FileEnvironmentResponseFile] = pydantic.Field(default=None)
    """
    The version of the File that is deployed to the Environment, if one is deployed.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
