# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel


class LinkedToolRequest(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    The ID of the linked tool. Starts with "oc\_"
    """

    source: typing.Literal["organization"] = pydantic.Field(default="organization")
    """
    The source of the linked tool. For a linked tool it should be `organization`
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the linked tool.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    The description of the linked tool.
    """

    parameters: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(default=None)
    """
    The parameters of the linked tool.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
