# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel
from .base_models_user_response import BaseModelsUserResponse
from .tool_source import ToolSource


class ToolConfigResponse(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    String ID of config. Starts with `config_`.
    """

    other: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(default=None)
    """
    Other parameters that define the config.
    """

    type: typing.Literal["tool"] = "tool"
    created_by: typing.Optional[BaseModelsUserResponse] = pydantic.Field(default=None)
    """
    The user who created the config.
    """

    status: str = pydantic.Field()
    """
    Whether the config is committed or not.
    """

    name: str = pydantic.Field()
    """
    Name for the tool referenced by the model.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    Description of the tool referenced by the model
    """

    source: typing.Optional[ToolSource] = pydantic.Field(default=None)
    """
    Source of the tool. If defined at an organization level will be 'organization' else 'inline'.
    """

    source_code: typing.Optional[str] = pydantic.Field(default=None)
    """
    Code source of the tool.
    """

    setup_schema: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(default=None)
    """
    Definition of parameters needed to run the tool. Provided in jsonschema format: https://json-schema.org/
    """

    parameters: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(default=None)
    """
    Definition of parameters needed to run the tool. Provided in jsonschema format: https://json-schema.org/
    """

    signature: typing.Optional[str] = pydantic.Field(default=None)
    """
    The function signature of the tool when being called.
    """

    is_preset: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether the tool is one where Humanloop defines runtime or not.
    """

    preset_name: typing.Optional[str] = pydantic.Field(default=None)
    """
    If is_preset = true, this is the name of the preset tool on Humanloop. This is used as the key to lookup the Humanloop runtime of the tool
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
